#ifndef __datatypes
#define __datatypes

#include "stm8s.h"

//    
typedef struct
{
	uint8_t degrees; // .          ,  = 1
	uint8_t minutes; // 
	uint16_t dp_minutes; //   
} GPS_COORD;


#define GPS_GPRMC_SOUTH_LAT 0x00
#define GPS_GPRMC_NORTH_LAT 0x80
#define GPS_GPRMC_WEST_LONG 0x00
#define GPS_GPRMC_EAST_LONG 0x80
#define GPS_GPRMC_INVALID 0x00
#define GPS_GPRMC_VALID 0x01

typedef struct
{
	uint32_t TIME; // unix-like  
	GPS_COORD LATITUDE; // 
	GPS_COORD LONGITUDE; // .     
	uint16_t GPS_SPEED; //   knots,   10.     
        uint8_t VALID; //   ( fix )
        uint8_t CTIME[4];
        uint8_t KSPEED[4];

} GPS_GPRMC;


typedef struct
{
  uint8_t keystring[12]; // = {0x01, 'G', 'P', 'S', '/', 'G', 'S', 'M', ' ', 'v', '1', '.'};
  uint32_t ClientID;
} SRV_INITPCK;



#endif
