#include "timeroutines.h"

uint8_t time_buf[6];
uint32_t months[13] =
	{
		0, // 
		31 * TIME_SEC_PER_DAY, // 
		28 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY, // 
		30 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY, // 
		30 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY, // 
		30 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY, // 
		30 * TIME_SEC_PER_DAY, // 
		31 * TIME_SEC_PER_DAY // 
	};	


void set_date_time_read()
{
/*
	//    
	rtccTimeDate datetime;
	mRtccWaitSync();
	RtccReadTimeDate(&datetime); //     
		
	time_buf[0] = datetime.f.mday;
	time_buf[1] = datetime.f.mon;
	time_buf[2] = datetime.f.year;
	time_buf[3] = datetime.f.hour;
	time_buf[4] = datetime.f.min;
	time_buf[5] = datetime.f.sec;
*/
}	


//     
void set_time_write()
{
/*
	mRtccWaitSync();
	
	  if(!mRtccIsWrEn())
      {
          RtccWrOn();
      }

	//RtccWriteTimeDate(&datetime, 0);
	RCFGCALbits.RTCPTR = 0b11; //year
	uint16_t tmp, tmp1;
	tmp = 0x0000 | (((uint16_t)time_buf[2]) & 0x00ff); // 
	RTCVAL = tmp;
	
	tmp = 0x0000 | (((uint16_t)time_buf[0]) & 0x00ff); // 
	tmp1 = (uint16_t) time_buf[1]; // 
	tmp1 = (tmp1 << 8) & 0xff00;
	tmp |= tmp1;
	
	//RTCVAL = 0x0412;
	RTCVAL = tmp;
	
	//RTCVAL = 0x0122;
	tmp = 0x0100 | (((uint16_t)time_buf[3]) & 0x00ff); // xfc
	RTCVAL = tmp; //     ,   
	
	tmp1 = (uint16_t) time_buf[4]; // 
	tmp1 = (tmp1 << 8) & 0xff00;
	
	tmp1 |= (uint16_t) time_buf[5]; // 
	//RTCVAL = 0x2600;
	RTCVAL = tmp1; //   
	mRtccOn();
	mRtccWrOff();
*/
}	


void set_initial_time(void)
{
	set_date_time_read();
	
	uint8_t year = ((time_buf[2] >> 4) & 0x0f) * 16 + (time_buf[2] & 0x0f);
	if ((year < 10) | (year > 20))
	{
		time_buf[0] = 0x27;
		time_buf[1] = 0x01;
		time_buf[2] = 0x11;
		time_buf[3] = 0x08;
		time_buf[4] = 0x00;
		set_time_write();
	}
}	
uint8_t time_days_on_months[13] =
 	{
	 	0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
	}; 
uint16_t is_leap_year(uint16_t year)
{
	uint8_t res = year / 4;
	res = res - (year * res);
	return res == 0;
}	

uint32_t get_unix_time(uint8_t * bcd_time_buf)
{	
	uint32_t res = TIME_BASE_TIME;
	int year = ((bcd_time_buf[0] >> 4) & 0x0f) * 10 + (bcd_time_buf[0] & 0x0f) + 2000;
	int month = ((bcd_time_buf[1] >> 4) & 0x0f) * 10 + (bcd_time_buf[1] & 0x0f);
	int day = ((bcd_time_buf[2] >> 4) & 0x0f) * 10 + (bcd_time_buf[2] & 0x0f);
	int hour = ((bcd_time_buf[3] >> 4) & 0x0f) * 10 + (bcd_time_buf[3] & 0x0f);
	int min = ((bcd_time_buf[4] >> 4) & 0x0f) * 10 + (bcd_time_buf[4] & 0x0f);

	//    
	if (year < 2010)
	 	return res;

	int temp = 2010;
	while (year > temp)
	{	
		if (is_leap_year(temp))
			res += TIME_SEC_PER_LEAP_YEAR;
		else
			res += TIME_SEC_PER_YEAR;
		temp++;
	}	
	
	temp = 1;
	while (month > temp)
	{
		if (temp == 2)
		{
			if (is_leap_year(year))
				res += months[temp] + TIME_SEC_PER_DAY;
			else
			 	res += months[temp];
		}		
		else
			res += months[temp];
			
		temp++;
	}	
	
	res += (day - 1) * TIME_SEC_PER_DAY;
	res += hour * (long int)TIME_SEC_PER_HOUR;
	res += min * 60;
	return res;
}	

void calc_unix_time(int year, int month, int day, int hour, int min, int sec, uint32_t * time)
{
	uint32_t res = TIME_BASE_TIME;
		//    
	if (year < 2010)
	{
		*time = res;
	 	return;
	} 	

	int temp = 2010;
	while (year > temp)
	{	
		if (is_leap_year(temp))
			res += TIME_SEC_PER_LEAP_YEAR;
		else
			res += TIME_SEC_PER_YEAR;
		temp++;
	}	
	
	temp = 1;
	while (month > temp)
	{
		if (temp == 2)
		{
			if (is_leap_year(year))
				res += months[temp] + TIME_SEC_PER_DAY;
			else
			 	res += months[temp];
		}		
		else
			res += months[temp];
			
		temp++;
	}	
	
	res += (day - 1) * TIME_SEC_PER_DAY;
	res += hour * (uint32_t)TIME_SEC_PER_HOUR;
	res += min * 60;
	res += sec;
	*time = res;
}	

uint8_t time_bcd_to_uint(uint8_t bcd)
{
	return ((bcd >> 4) & 0x0f) * 10 + (bcd & 0x0f);
}	

uint8_t time_uint_to_bcd(uint8_t uint)
{
	uint8_t res, res1;
	res = uint / 10;
	res1 = uint - res * 10;
	return ((res << 4)  & 0xf0) | res1;
}	

uint8_t time_bcd_dec(uint8_t bcd)
{
	return time_uint_to_bcd((time_bcd_to_uint(bcd) - 1));
}	