#ifndef __timeroutines
#define __timeroutines

#include "datatypes.h"


//  unix      YYMMDDHHMM
#define TIME_BASE_TIME 1262304000   // 1001010000  aka 01.01.2010 00:00 GMT
#define TIME_SEC_PER_DAY 86400
#define TIME_SEC_PER_HOUR 3600
#define TIME_SEC_PER_YEAR 31536000
#define TIME_SEC_PER_LEAP_YEAR 31622400

extern uint8_t time_buf[6];
extern void set_date_time_read();
extern void set_time_write();
extern void set_initial_time(void);
extern uint8_t time_days_on_months[13];
extern uint32_t get_unix_time(uint8_t * bcd_time_buf);
extern void calc_unix_time(int year, int month, int day, int hour, int min, int sec, uint32_t * time);
extern uint16_t is_leap_year(uint16_t year);
extern uint8_t time_bcd_to_uint(uint8_t bcd);
extern uint8_t time_uint_to_bcd(uint8_t uint);
extern uint8_t time_bcd_dec(uint8_t bcd);
#endif

